import 'package:country_codes/country_codes.dart';
import 'package:geolocator/geolocator.dart';
import 'package:get/get.dart';

class LocationController {
  var serviceEnabled = false.obs;
  var permission = Rxn<LocationPermission>();
  var position = Rxn<Position>();

  var localeCountry = '';
  var localeLang = '';

  Future<LocationController> init() async {
    await _init();
    return this;
  }

  Future<void> _init() async {
    serviceEnabled.value = await Geolocator.isLocationServiceEnabled();
    permission.value = await Geolocator.checkPermission();

    getPosition();

    await CountryCodes.init();
    var deviceLocale = CountryCodes.getDeviceLocale();
    if (deviceLocale == null) return;

    localeCountry = deviceLocale.countryCode ?? '';
    localeLang = deviceLocale.languageCode;
  }

  bool _validate() {
    if (!serviceEnabled.value &&
        (permission.value == LocationPermission.denied ||
            permission.value == LocationPermission.deniedForever)) return false;

    return true;
  }

  void getPosition() async {
    if (!_validate()) return;

    position.value = await Geolocator.getCurrentPosition();
  }
}
