import 'package:rdc_flutter_sdk/src/model/user_info.dart';
import 'package:rdc_flutter_sdk/src/repositories/user_info_repo.dart';

class UserInfoController {
  final _userInfoRepo = UserInfoRepo();
  final userInfo = UserInfo();

  Future<UserInfoController> init() async {
    await _hasData();
    return this;
  }

  Future<void> _hasData() async {
    var users = await _userInfoRepo.getAll();
    if (users.isEmpty) return;

    userInfo
      ..memberId = users[0].memberId
      ..ssoId = users[0].ssoId;
  }

  Future<void> save() async {
    await _userInfoRepo.deleteAll();
    await _userInfoRepo.insert(userInfo);
  }
}
