import 'package:get/get_state_manager/get_state_manager.dart';
import 'package:rdc_flutter_sdk/src/database/db_interface.dart';
import 'package:realm/realm.dart';

class RealmDBImpl extends GetxController implements RealmDBInterface {
  @override
  late Realm db;

  RealmDBImpl(Realm realm) {
    db = realm;
  }

  @override
  List<T> getAll<T extends RealmObject>() {
    var results = db.all<T>();
    return results.toList();
  }

  @override
  T? get<T extends RealmObject>(int id) {
    var result = db.find<T>(id);
    return result;
  }

  @override
  bool insert<T extends RealmObject>(T data) {
    db.write(() => db.add<T>(data));
    return true;
  }

  @override
  bool edit<T extends RealmObject>(int id, T data) {
    var item = db.find<T>(id);
    if (item == null) return false;
    db.write(() {
      item = data;
    });

    return true;
  }

  @override
  void delete<T extends RealmObject>(T data) {
    db.write(() => db.delete<T>(data));
  }

  @override
  void deleteAll<T extends RealmObject>() {
    db.write(() => db.deleteAll<T>());
  }
}
