import 'package:rdc_flutter_sdk/src/model/rabbit_enum.dart';

class RabbitDataConfig {
  String apiEndpoint = 'https://api-staging.rdc.rabbit.co.th/v1';
  String apiKey;
  String encryptKey;
  DataCollectionType collectionType;
  Duration rotationTime;
  int retentionDays;
  int retryTime;
  bool offlineMode;
  bool deleteAfterSent;
  TriggerCondition trigger;
  DBType dbType;

  RabbitDataConfig(
      {required this.apiKey,
      this.encryptKey = '',
      this.collectionType = DataCollectionType.event,
      this.rotationTime = const Duration(minutes: 5),
      this.retentionDays = 7,
      this.retryTime = 3,
      this.offlineMode = true,
      this.deleteAfterSent = true,
      this.trigger = const TriggerCondition(),
      this.dbType = DBType.hive});
}

class TriggerCondition {
  const TriggerCondition(
      {double cpu = 0.0, double memory = 0.0, double betteryLevel = 0.0});
}
