import 'package:rdc_flutter_sdk/src/model/base_model.dart';
import 'package:rdc_flutter_sdk/src/model/hive/user_info_hive.dart';
import 'package:rdc_flutter_sdk/src/model/realm/user_info_realm.dart';

class UserInfo extends BaseModel<UserInfoHive, UserInfoRealm> {
  String memberId;
  String ssoId;

  UserInfo({this.memberId = '', this.ssoId = ''});

  static String boxName = 'user_info';

  @override
  UserInfoHive mapToHive() {
    return UserInfoHive()
      ..memberId = memberId
      ..ssoId = ssoId;
  }

  @override
  UserInfoRealm mapToRealm() {
    return UserInfoRealm(memberId, ssoId);
  }
}
