import 'dart:convert';

import 'base_model.dart';
import 'hive/version_hive.dart';
import 'realm/version_realm.dart';

class Version extends BaseModel<VersionHive, VersionRealm> {
  Version({
    this.id = 0,
    this.appVer = '',
    this.appVerNum = '',
    this.prevAppVer = '',
    this.prevAppVerNum = '',
  });

  int id;

  String appVer;

  String appVerNum;

  String prevAppVer;

  String prevAppVerNum;

  static String boxName = 'version';

  factory Version.fromRawJson(String str) => Version.fromJson(json.decode(str));

  String toRawJson() => json.encode(toJson());

  factory Version.fromJson(Map<String, dynamic> json) => Version(
        appVer: json["app_ver"],
        appVerNum: json["app_ver_num"],
        prevAppVer: json["prev_app_ver"],
        prevAppVerNum: json["prev_app_ver_num"],
      );

  Map<String, dynamic> toJson() => {
        "app_ver": appVer,
        "app_ver_num": appVerNum,
        "prev_app_ver": prevAppVer,
        "prev_app_ver_num": prevAppVerNum,
      };

  @override
  VersionHive mapToHive() {
    return VersionHive()
      ..appVer = appVer
      ..appVerNum = appVerNum
      ..prevAppVer = prevAppVer
      ..prevAppVerNum = prevAppVerNum;
  }

  @override
  VersionRealm mapToRealm() {
    return VersionRealm(appVer, appVerNum, prevAppVer, prevAppVerNum);
  }
}
