import 'package:rdc_flutter_sdk/src/model/rabbit_data_config.dart';
import 'package:rdc_flutter_sdk/src/model/rabbit_enum.dart';

abstract class RabbitDataInstance {
  Future<RabbitDataInstance> initializeInstance(RabbitDataConfig config);

  /*---------- override config ----------- */
  void setAPIKey(String id);
  void setEncryptionKey(String id);
  void setRotationTime(Duration duration);
  void setDataCollectionType(DataCollectionType type);
  void setRetentionDays(int date);
  void setRetryOnFailed(int time);
  void setDeleteAfterSent(bool value);
  void setTriggerCondition(
      {double cpu = 0.0, double memory = 0.0, double betteryLevel = 0.0});
  void setDatabaseType(DBType type);
  /*---------- override config ----------- */

  /*---------- set value ----------- */
  Future<void> setUserInfo(String memberId, String ssoId);
  /*---------- set value ----------- */

  /*---------- event ----------- */
  Future<void> addEvent(
      {required String eventName,
      required String eventValue,
      String sessionEvent = '',
      Map<dynamic, dynamic>? dataLayer});
  Future<void> uploadEvent();
  Future<void> clearCache();
  Future<void> sessionStart();
  Future<void> sessionEnd();
  /*---------- event ----------- */
}
